function [y,u,e,c,PHI,rho,phi,up,lamb,ep,eps,ye,X,i,w,vx,I_mU,sig,theta,na,nb,x]=initialize(ki,controller,N,iniValue)
    
// Initialization of model/controller variables
c=0
PHI=0
rho=0
phi=0
up=0
lamb=0
ep=0
eps=0
ye=0
X=0
i=0
w=0
vx=0
I_mU=0
sig=0
y=zeros(ki-1,1)
e=zeros(ki-1,1)
u=zeros(ki-1,1)
x=[1:N]'*T0

 
// Definition on the order of the model to be used on the controller
if controller == '1' |controller == 'Dahlin' then
    na = 2;
    nb = 1;
    theta(1:na+nb,ki-1)=[iniValue iniValue iniValue ]'
elseif controller == '2'|controller =='Banyasz' then
    na = 2;
    nb = 2;
    theta (1:na+nb,ki-1)= iniValue*ones(1 , na + nb)';
elseif controller == '3'|controller =='Pole Placement' then
    na = 2;
    nb = 2;
    theta(1:na+nb,ki-1)=[-iniValue iniValue iniValue iniValue]'
elseif controller == '4'|controller =='Deadbeat 2nd' then
    na = 2;
    nb = 2;
    theta(1:na+nb,ki-1) = iniValue*ones(1 , na + nb)'; 
elseif controller == '5'|controller =='Deadbeat 3rd' then
    na = 3;
    nb = 3;
    theta(1:na+nb,ki-1)=[iniValue iniValue iniValue iniValue iniValue iniValue]'
elseif controller == '6'|controller =='Ziegler Nichols FR' then
    na = 3;
    nb = 3;
    theta(1:na+nb,ki-1)=[iniValue iniValue iniValue iniValue iniValue iniValue]'
elseif controller == '7'|controller =='Single Neuron' then
    na = 2
    nb = 1
    theta(1:3,ki-1)=[iniValue iniValue iniValue]'
    i(ki-1) = 1;
    X(ki-1,1:3) = [iniValue iniValue iniValue];
    u(ki-1) = 1;
    w(ki-1,1:3) = [1 1 1]
elseif controller == '8'|controller =='LSSVR' then
    na=2
    nb=1
    theta(1:3,ki-1)=[iniValue iniValue iniValue]'
elseif controller == '9'|controller =='LSSVRKT' then
    na=2
    nb=1
    theta(1:3,ki-1)=[iniValue iniValue iniValue]'
end

// Initialization for Single_Neuron controller
if controller == 'Single_Neuron'| controller == '7' then
    ye(1:N) = 0;
    ep(1:N) = 0
end
      
endfunction
